/*
 * Copyright (C) 2018 CERN
 * Author: Maciej Suminski <maciej.suminski@cern.ch>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QBoxLayout>
#include "diot_dialog.h"

DIOT_Dialog::DIOT_Dialog(int address, int slots_nr)
    : hw(address, slots_nr)
{
    QVBoxLayout *mainLayout = new QVBoxLayout();

    DiotIOController *controller = new DiotIOController(this, hw, slots_nr);
    mainLayout->addWidget(controller);

    DiotDiag *diag = new DiotDiag(this, hw);
    mainLayout->addWidget(diag);

    setLayout(mainLayout);
    hw.Start();
}
