#ifndef __CHEBY__PLC_URV_REGS__H__
#define __CHEBY__PLC_URV_REGS__H__

#include "mbox_regs.h"
#define PLC_URV_REGS_SIZE 73824

/* None */
#define PLC_URV_REGS_SRAM 0x10000UL
#define PLC_URV_REGS_SRAM_SIZE 4

/* None */
#define PLC_URV_REGS_SRAM_VALUE 0x0UL

/* None */
#define PLC_URV_REGS_MAILBOXES 0x12000UL
#define PLC_URV_REGS_MAILBOXES_SIZE 16

/* presence lines for boards */
#define PLC_URV_REGS_PRESENCE 0x12010UL
#define PLC_URV_REGS_PRESENCE_EN_MASK 0xffUL
#define PLC_URV_REGS_PRESENCE_EN_SHIFT 0

/* None */
#define PLC_URV_REGS_LOOPS 0x12020UL
#define PLC_URV_REGS_LOOPS_SIZE 32

/* None */
#define PLC_URV_REGS_LOOPS_PINS_0 0x12020UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_1 0x12024UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_2 0x12028UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_3 0x1202cUL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_4 0x12030UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_5 0x12034UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_6 0x12038UL

/* None */
#define PLC_URV_REGS_LOOPS_PINS_7 0x1203cUL

/* None */
#define PLC_URV_REGS_RELAYS 0x12040UL
#define PLC_URV_REGS_RELAYS_SIZE 32

/* None */
#define PLC_URV_REGS_RELAYS_PINS_0 0x12040UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_1 0x12044UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_2 0x12048UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_3 0x1204cUL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_4 0x12050UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_5 0x12054UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_6 0x12058UL

/* None */
#define PLC_URV_REGS_RELAYS_PINS_7 0x1205cUL

struct plc_urv_regs {

  /* padding to: 16384 words */
  uint32_t __padding_0[16384];
  /* [0x10000]: MEMORY (no description) */
  struct sram {
    /* [0x0]: REG (rw) (no description) */
    uint32_t value;
  } sram[2048];

  /* [0x12000]: SUBMAP (no description) */
  struct mbox_regs mailboxes;

  /* padding to: 18436 words */
  uint32_t __padding_1[1];

  /* [0x12010]: REG (ro) presence lines for boards */
  uint32_t presence;

  /* padding to: 18440 words */
  uint32_t __padding_2[3];

  /* [0x12020]: BLOCK (no description) */
  struct loops {
    /* [0x0]: REG (ro) (no description) */
    uint32_t pins_0;

    /* [0x4]: REG (ro) (no description) */
    uint32_t pins_1;

    /* [0x8]: REG (ro) (no description) */
    uint32_t pins_2;

    /* [0xc]: REG (ro) (no description) */
    uint32_t pins_3;

    /* [0x10]: REG (ro) (no description) */
    uint32_t pins_4;

    /* [0x14]: REG (ro) (no description) */
    uint32_t pins_5;

    /* [0x18]: REG (ro) (no description) */
    uint32_t pins_6;

    /* [0x1c]: REG (ro) (no description) */
    uint32_t pins_7;
  } loops;

  /* [0x12040]: BLOCK (no description) */
  struct relays {
    /* [0x0]: REG (rw) (no description) */
    uint32_t pins_0;

    /* [0x4]: REG (rw) (no description) */
    uint32_t pins_1;

    /* [0x8]: REG (rw) (no description) */
    uint32_t pins_2;

    /* [0xc]: REG (rw) (no description) */
    uint32_t pins_3;

    /* [0x10]: REG (rw) (no description) */
    uint32_t pins_4;

    /* [0x14]: REG (rw) (no description) */
    uint32_t pins_5;

    /* [0x18]: REG (rw) (no description) */
    uint32_t pins_6;

    /* [0x1c]: REG (rw) (no description) */
    uint32_t pins_7;
  } relays;
};

#endif /* __CHEBY__PLC_URV_REGS__H__ */
